#include <stdio.h>
#include <stdlib.h>

typedef struct _destinacija{
    char naziv[31];
    int cijena;
}destinacija;

typedef struct _student{
    char ime[31];
    int n;
    destinacija* zelje;
}student;

destinacija* odgovara(student* niz, int m)
{
    destinacija* presjek=NULL;
    int i, j, k, postoji, prvi=1;

    if(!m) //ako nemamo niti jednog studenta nemamo sto raditi
        return presjek;

    for(i=0; i<niz[0].n; i++){
        for(j=1; j<m; j++){
            postoji=0;
            for(k=0; k<niz[j].n; k++){
               if(!strcmp(niz[0].zelje[i].naziv,niz[j].zelje[k].naziv)){
                    postoji=1;
                    break;
               }
            }
            if(!postoji)
                break;
        }

        if(!postoji)
            continue;

        //niz[0].zelje[i] je destinacija u presjeku
        if(prvi){
            presjek=(destinacija*)malloc(sizeof(destinacija));
            *presjek=niz[0].zelje[i];
            prvi=0;
        }
        else{
            if(niz[0].zelje[i].cijena<presjek[0].cijena || (niz[0].zelje[i].cijena==presjek[0].cijena && strcmp(niz[0].zelje[i].naziv,presjek[0].naziv)<0))
                *presjek=niz[0].zelje[i];
        }
    }

    return presjek;
}

void ispis(student a)
{
	int i;

	printf("%s\n", a.ime);
	for(i=0; i<a.n; i++)
		printf("%d) %s (%d)\n", i+1, a.zelje[i].naziv, a.zelje[i].cijena);
	printf("\n");
	return;
}

int main(void)
{
    student* niz;
    destinacija* odg;
    int m, i, j;

    printf("Ucitaj broj studenata: ");
    scanf("%d", &m);
    niz=(student*)malloc(m*sizeof(student));

    for(i=0; i<m; i++){
        printf("Unesi ime %d. studenta: ", i+1);
        scanf(" %[^\n]", niz[i].ime);
        printf("Unesi broj zeljenih destinacija: ");
        scanf("%d", &niz[i].n);
        niz[i].zelje=(destinacija*)malloc(niz[i].n*sizeof(destinacija));
        for(j=0; j<niz[i].n; j++){
            printf("Unesi naziv destinacije: ");
            scanf(" %[^\n]", niz[i].zelje[j].naziv);
            printf("Unesi cijenu: ");
            scanf("%d", &niz[i].zelje[j].cijena);
        }
    }

	for(i=0; i<m; i++)
		ispis(niz[i]);

    odg=odgovara(niz,m);
    if(odg)
        printf("\nU presjeku je destinacija: %s (%d)\n", odg->naziv, odg->cijena);
	else
		printf("\nNema destinacije u presjeku!\n");

    free(odg);
	free(niz);

    return 0;
}
